﻿Imports Microsoft.Speech.Recognition ' Microsoft.Speech.dll at C:\Program Files (x86)\Microsoft SDKs\Speech\v11.0\Assembly
Imports Microsoft.Speech.Synthesis
Imports System.Globalization ' recognition

Namespace ConsoleSpeech
	Friend Class ConsoleSpeechProgram
        Private Shared ss As New SpeechSynthesizer
		Private Shared sre As SpeechRecognitionEngine
		Private Shared done As Boolean = False
		Private Shared speechOn As Boolean = True

		Shared Sub Main(ByVal args() As String)
			Try
				ss.SetOutputToDefaultAudioDevice()
                Console.WriteLine(vbCrLf & "(Speaking: I am awake)")
				ss.Speak("I am awake")

				Dim ci As New CultureInfo("en-us")
				sre = New SpeechRecognitionEngine(ci)
				sre.SetInputToDefaultAudioDevice()
				AddHandler sre.SpeechRecognized, AddressOf sre_SpeechRecognized

                Dim ch_StartStopCommands As New Choices
				ch_StartStopCommands.Add("speech on")
				ch_StartStopCommands.Add("speech off")
				ch_StartStopCommands.Add("klatu barada nikto")
                Dim gb_StartStop As New GrammarBuilder
				gb_StartStop.Append(ch_StartStopCommands)
				Dim g_StartStop As New Grammar(gb_StartStop)

                'Dim numbers = New String() {"1", "2", "3", "4"}
                'Dim ch_Numbers = New Choices(numbers)

                'Dim numbers = New String(100)
                ' For i As Integer = 0To 100
                'numbersi = i.ToString
                ' Dim ch_Numbers = New Choices(numbers)
                'Next


                Dim ch_Numbers As New Choices
                ch_Numbers.Add("1")
                ch_Numbers.Add("2")
                ch_Numbers.Add("3")
                ch_Numbers.Add("4") ' technically Add(New String() {"4"})

                'For num As Integer = 1 To 4
                'ch_Numbers.Add(num.ToString())
                'Next


                Dim gb_WhatIsXplusY As New GrammarBuilder
                gb_WhatIsXplusY.Append("What is")
                gb_WhatIsXplusY.Append(ch_Numbers)
                gb_WhatIsXplusY.Append("plus")
                gb_WhatIsXplusY.Append(ch_Numbers)
                Dim g_WhatIsXplusY As New Grammar(gb_WhatIsXplusY)

                sre.LoadGrammarAsync(g_StartStop)
                sre.LoadGrammarAsync(g_WhatIsXplusY)

                sre.RecognizeAsync(RecognizeMode.Multiple) ' multiple grammars

                Do While done = False

                Loop

                Console.WriteLine(vbCrLf & "Hit <enter> to close shell" & vbCrLf)
                Console.ReadLine()
            Catch ex As Exception
                Console.WriteLine(ex.Message)
                Console.ReadLine()
            End Try

		End Sub ' Main

		Private Shared Sub sre_SpeechRecognized(ByVal sender As Object, ByVal e As SpeechRecognizedEventArgs)
			Dim txt As String = e.Result.Text
			Dim confidence As Single = e.Result.Confidence ' consider implicit cast to double
            Console.WriteLine(vbCrLf & "Recognized: " & txt)

			If confidence < 0.60 Then
                Exit Sub
			End If

			If txt.IndexOf("speech on") >= 0 Then
				Console.WriteLine("Speech is now ON")
				speechOn = True
			End If

			If txt.IndexOf("speech off") >= 0 Then
				Console.WriteLine("Speech is now OFF")
				speechOn = False
			End If

			If speechOn = False Then
                Exit Sub
			End If

			If txt.IndexOf("klatu") >= 0 AndAlso txt.IndexOf("barada") >= 0 Then
                CType(sender, SpeechRecognitionEngine).RecognizeAsyncCancel 
				done = True
				Console.WriteLine("(Speaking: Farewell)")
				ss.Speak("Farewell")
			End If

			If txt.IndexOf("What") >= 0 AndAlso txt.IndexOf("plus") >= 0 Then ' what is 2 plus 3
				Dim words() As String = txt.Split(" "c) ' or use e.Result.Words
				Dim num1 As Integer = Integer.Parse(words(2))
				Dim num2 As Integer = Integer.Parse(words(4))
				Dim sum As Integer = num1 + num2
				Console.WriteLine("(Speaking: " & words(2) & " plus " & words(4) & " equals " & sum & ")")
				ss.SpeakAsync(words(2) & " plus " & words(4) & " equals " & sum)
			End If
		End Sub ' sre_SpeechRecognized

	End Class ' Program

End Namespace ' ns
